if( !Object.assign ) {
    Object.defineProperty(Object, 'assign', {
        enumerable      : false,
        configurable    : true,
        writable        : true,
        value           : function(target) {
            
            'use strict';

            if( target === undefined || target === null ) {
                throw new TypeError('Cannot convert first argument to object');
            }

            var to = Object(target);

            for( var i = 1; i < arguments.length; i++ ) {
                
                var nextSource = arguments[i];
                if( nextSource === undefined || nextSource === null ) {
                    continue;
                }

                nextSource = Object(nextSource);

                var keysArray = Object.keys(Object(nextSource));
                for (var nextIndex = 0, len = keysArray.length; nextIndex < len; nextIndex++) {
                    
                    var nextKey = keysArray[nextIndex];
                    var desc = Object.getOwnPropertyDescriptor(nextSource, nextKey);
                    
                    if (desc !== undefined && desc.enumerable) {
                        to[nextKey] = nextSource[nextKey];
                    }

                }

            }
            return to;
        }
    });
}

// https://github.com/uxitten/polyfill/blob/master/string.polyfill.js
// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/padStart
if (!String.prototype.padStart) {
    String.prototype.padStart = function padStart(targetLength, padString) {
        targetLength = targetLength >> 0; //truncate if number, or convert non-number to 0;
        padString = String(typeof padString !== 'undefined' ? padString : ' ');
        if (this.length >= targetLength) {
            return String(this);
        } else {
            targetLength = targetLength - this.length;
            if (targetLength > padString.length) {
                padString += padString.repeat(targetLength / padString.length); //append to original to ensure we are longer than needed
            }
            return padString.slice(0, targetLength) + String(this);
        }
    };
}